#import <Cocoa/Cocoa.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/glext.h>
#import <GLUT/glut.h>
#import "SBGLObject.h"
#import "Quaternions.h"

extern GLfloat					gSelectionColor[4];

//typedef	GLfloat	VECTOR3D[3];

enum {
	kPointPo = 0,
	kPointC1 = 1,
	kPointC2 = 2
};

//////////////////////////////////////////////
@interface SBGLPath : SBGLObject
{
	SB3DBezierPath	*gPath;
	int				gSelectedPointIndex;
	SB3DBezierPoint	*selectedPoint, *brotherPoint;
	BOOL			gPenPathInDrawing, gAddingPoint;
	BOOL			gHasBrother;
	int				gSelectedPointKind;
	BOOL			gLastClickHasSelected;
	BOOL			gHaDraggato;
	GLfloat			gSizeMinX, gSizeMinY, gSizeMinZ, gSizeMaxX, gSizeMaxY, gSizeMaxZ;
	
	GLfloat			vPoint[3], linkPoint[3];
	SB3DPoint		pS, c1, c2, pE;
	int				gTotPointsTimeCode;
	GLfloat			**gTimeCode;
	GLfloat			**gTangentCode;
}
- (NSMutableArray*)GetPathArray;
- (void)SetPathArray:(NSMutableArray*)pathArray;

- (BOOL)mouseDown:(NSEvent*)theEvent;
- (BOOL)mouseDragged:(NSEvent*)theEvent;
- (void)mouseUp:(NSEvent*)theEvent;

- (void)ManagePointHorto:(NSPoint)curPoint distanzaC1:(float)distanzaC1 distanzaC2:(float)distanzaC2;
- (void)ManagePointPerspective:(float)dx dy:(float)dy flags:(unsigned int)flags 
		distanzaC1:(float)distanzaC1 distanzaC2:(float)distanzaC2
		vectorCoeffMC1:(float*)vectorCoeffMC1 vectorCoeffMC2:(float*)vectorCoeffMC2;
- (void)EnableInspectorSliders;
- (void)UpdateInspector;
- (void)SetSelectedPoint:(int)selectedPoint andKind:(int)kind;
- (int)gSelectedPointIndex;

- (void)AddPoint:(NSPoint)mouseLoc;
- (void)ReallocPointsInPath:(int)totPoints;
- (void)DeleteSelectedPoint;

- (BOOL)SelectPointAt:(NSPoint)mouseLoc;
- (void)GetTimeCode;
- (void)InitTimeCode;
- (void)ReleaseTimeCode;
- (void)UpdateTimeCodeLength;
- (void)GetTimeCodeForPath;
- (void)CalculateMinMaxSize;

- (void)ProjectPoint:(GLfloat*)srcPoint ToScreenCoordinates:(GLfloat*)dstPoint;
- (int)UnprojectPoint:(GLfloat*)srcPoint ToWorldCoordinates:(GLfloat*)dstPoint;

- (void)PlaceObjectWithSpriteCode:(float**)timeCode andTime:(int)t;
- (void)GetCurvePointAtTime:(GLfloat)t;
- (void)GetTangentAtTime:(GLfloat)t;

- (void)GetLinkedPoint:(GLfloat*)linkedPoint atGlobalTime:(int)globalTime;
- (void)GetTangentPoint:(GLfloat*)tangentPoint;
@end